<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.7 [en] (Win98; I) [Netscape]">
   <title>ExoticaX API Docs - D3DX Library Page</title>
</head>
<body text="#FFFFFF" bgcolor="#000000" link="#0000FF" vlink="#00CC66" alink="#FF0000">

<center><b><font face="Brush455 BT, Comic Sans MS"><font color="#FF0000"><font size=+3>D3dX.ew
API Documentation</font></font></font></b>
<br>
<hr WIDTH="50%" COLOR="#FF0000">
<p><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>A note
on using D3DX.ew</font></font></font></center>

<center><table BORDER COLS=1 WIDTH="75%" >
<tr>
<td>&nbsp;&nbsp;&nbsp;&nbsp; For some unknown reason, in order for colors
to be displayed correctly when using 3D routines, you must wrap all the
ExoticaX Init calls in a routine. Which can be called directly afterwards.
I have not been able to solve this problem any other way. For examples
of what I mean, see the E3D Demos.</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER COLS=1 WIDTH="50%" >
<tr>
<td><b><font face="Comic Sans MS"><font size=+1><a href="#D3_RT">Runtime
Routines</a></font></font></b></td>
</tr>

<tr>
<td>
<blockquote>
<dt>
<font face="Comic Sans MS"><a href="#D3D_INIT">d3d_init()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#D3D_RELEASE">d3d_release()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#IS_ZBUFFERLESSHSR">is_zbufferlesshsr()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#CREATE3D_DEVICE">create3d_device()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#CREATE_VIEWPORT">create_viewport()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#CLEAR_VIEWPORT">clear_viewport()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#GET_VIEWPORT">get_viewport()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#BEGIN_SCENE">begin_scene()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#END_SCENE">end_scene()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#GET_D3D_MEMORY_MODE">get_d3d_memory_mode()</a></font></dt>
</blockquote>
</td>
</tr>
</table></center>

<center><table BORDER COLS=1 WIDTH="50%" >
<tr>
<td><b><font face="Comic Sans MS"><font size=+1><a href="#D3_RS">Render
Surface Routines</a></font></font></b></td>
</tr>

<tr>
<td>
<blockquote>
<dt>
<font face="Comic Sans MS"><a href="#RS_ANTIALIAS_SORTDEPENDENT">rs_antialias_sortdependent()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_ANTIALIAS_SORTINDEPENDENT">rs_antialias_sortindependent()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_ANTIALIAS_NONE">rs_antialias_none()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_ENABLE_ALPHABLEND">rs_enable_alphablend()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_DISABLE_ALPHABLEND">rs_disable_alphablend()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_SRCBLEND">rs_srcblend()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_DESTBLEND">rs_destblend()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_ENABLE_Z_BUFFERING">rs_enable_z_buffering()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_ENABLE_W_BUFFERING">rs_enable_w_buffering()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_DISABLE_DEPTH_BUFFERING">rs_disable_depth_buffering()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_ENABLE_LIGHTING">rs_enable_lighting()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_DISABLE_LIGHTING">rs_disable_lighting()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#RS_SET_AMBIENT_COLOR">rs_set_ambient_color()</a></font></dt>
</blockquote>
</td>
</tr>
</table></center>

<center><table BORDER COLS=1 WIDTH="50%" >
<tr>
<td><b><font face="Comic Sans MS"><font size=+1><a href="#D3_TF">Transform
Routines</a></font></font></b></td>
</tr>

<tr>
<td>
<blockquote>
<dt>
<font face="Comic Sans MS"><a href="#SET_TRANSFORM_WORLD">set_transform_world()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#SET_TRANSFORM_VIEW">set_transform_view()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#SET_TRANSFORM_PROJECTION">set_transform_projection()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#GET_TRANSFORM_WORLD">get_transform_world()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#GET_TRANSFORM_VIEW">get_transform_view()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#GET_TRANSFORM_PROJECTION">get_transform_projection()</a></font></dt>
</blockquote>
</td>
</tr>
</table></center>

<center><table BORDER COLS=1 WIDTH="50%" >
<tr>
<td><b><font face="Comic Sans MS"><font size=+1><a href="#D3_ML">Materials
and Lighting Routines</a></font></font></b></td>
</tr>

<tr>
<td>
<blockquote>
<dt>
<font face="Comic Sans MS"><a href="#SET_MATERIALS">set_materials()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#SET_LIGHT">set_light()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#GET_LIGHT">get_light()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#LIGHT_ENABLE">light_enable()</a></font></dt>
</blockquote>
</td>
</tr>
</table></center>

<center><table BORDER COLS=1 WIDTH="50%" >
<tr>
<td><b><font face="Comic Sans MS"><font size=+1><a href="#D3_TX">Texture
Routines</a></font></font></b></td>
</tr>

<tr>
<td>
<blockquote>
<dt>
<font face="Comic Sans MS"><a href="#LOAD_TEXTURE_BITMAP">load_texture_bitmap()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#LOAD_TEXTURE_FAILED">load_texture_bitmap_failed()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#FREE_TEXTURE">free_texture()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#SET_TEXTURE_STAGE_STATE">set_texture_stage_state()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#GET_TEXTURE_STAGE_STATE">get_texture_stage_state()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#IS_TEXTURE_FORMAT">is_texture_format()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#SET_TEXTURE">set_texture()</a></font></dt>
</blockquote>
</td>
</tr>
</table></center>

<center><table BORDER COLS=1 WIDTH="50%" >
<tr>
<td><b><font face="Comic Sans MS"><font size=+1><a href="#D3_DP">Draw Primitive
Routines</a></font></font></b></td>
</tr>

<tr>
<td>
<blockquote>
<dt>
<font face="Comic Sans MS"><a href="#DRAW_PRIMITIVE">draw_primitive()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#DRAW_INDEXED_PRIMITIVE">draw_indexed_primitive()</a></font></dt>
</blockquote>
</td>
</tr>
</table></center>

<center><table BORDER COLS=1 WIDTH="50%" >
<tr>
<td><b><font face="Comic Sans MS"><font size=+1><a href="#D3_M">Math Routines</a></font></font></b></td>
</tr>

<tr>
<td>
<blockquote>
<dt>
<font face="Comic Sans MS"><a href="#CROSS_PRODUCT">cross_product()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#DOT_PRODUCT">dot_product()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#SQUARE_MAGNITUDE">square_magnitude()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MAGNITUDE">magnitude()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MAX_COMPONENT">max_component()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MIN_COMPONENT">min_component()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MAXIMIZE_COMPONENTS">maximize_components()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MINIMIZE_COMPONENTS">minimize_components()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#NORMALIZE_VECTOR">normalize_vector()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MATRIX_MULTIPLY">matrix_multiply()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MATRIX_INVERT">matrix_invert()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#VECTOR_MATRIX_MULTIPLY">vector_matrix_multiply()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#VERTEX_MATRIX_MULTIPLY">vertex_matrix_multiply()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#QUATERNION_FROM_ROTATION">quaternion_from_rotation()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#ROTATION_FROM_QUATERNION">rotation_from_quaternion()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#QUATERNION_FROM_ANGLES">quaternion_from_angles()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MATRIX_FROM_QUATERNION">matrix_from_quaternion()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#QUATERNION_FROM_MATRIX">quaternion_from_matrix()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#QUATERNION_MULTIPLY">quaternion_multiply()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#QUATERNION_SLERP">quaternion_slerp()</a></font></dt>

<dt>
<font face="Comic Sans MS"><a href="#MAKE_IDENTITY_MATRIX">make_identity_matrix()</a></font></dt>
</blockquote>
</td>
</tr>
</table></center>

<p>
<hr WIDTH="75%" COLOR="#FF0000">
<center>
<p><a NAME="D3_RT"></a><u><font face="Comic Sans MS"><font color="#FF0000"><font size=+2>Runtime
Routines</font></font></font></u></center>

<p><br>
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="D3D_INIT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>d3d_init()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Initializes the Direct3D component of exotica. DDraw needs
to be loaded to use D3D.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="D3D_RELEASE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>d3d_release()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Releases the D3D component of exotica. exotica_exit() will
do this.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="IS_ZBUFFERLESSHSR"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>is_zbufferlesshsr()</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns 1 if the hardware supports z-buffer-less hidden surface
removal, 0 if not. If it does, there's no need for a zbuffer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="CREATE3D_DEVICE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>create3d_device(
<i>integer
Mode, Zbuffer_Depth </i>)</font>
<blockquote><b><i>Mode</i></b> is either 0=software, 1=hardware
<br><b><i>Zbuffer_Depth</i></b> is the depth of the z_buffer if any</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Creates a 3D device for rendering the 3D scenes. You can optionally
create a zbuffer with a depth of either 8,16,24, or 32. You can specify
0 if you dont want to create a zbuffer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="CREATE_VIEWPORT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>create_viewport(
<i>atom
X, atom Y, atom Width, atom Height, atom MinZ, atom MaxZ </i>)</font>
<blockquote><b><i>X, Y</i></b> is the position on the surface where the
viewport will be
<br><b><i>Width, Height</i></b> is the size of the viewport
<br><b><i>MinZ, MaxZ</i></b> is the zbuffer depth range</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Creates a viewport at the specified position of the specified
size with the specified zbuffer_depth range for displaying the 3D scene.
The maximum range for the zbuffer is 0.0, being near, and 1.0, being far.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="CLEAR_VIEWPORT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>clear_viewport(
<i>atom
Flag, atom Color, atom Zvalue </i>)</font>
<blockquote><b><i>Flag</i></b> can be either D3DCLEAR_TARGET, or D3DCLEAR_ZBUFFER,
you can also OR them together
<br><b><i>Color</i></b> is the color you want to clear the viewport to
<br><b><i>Zvalue</i></b> is the value you want to clear the zbuffer to</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Clears the viewport and/or the zbuffer to the specified value.
Color is for the viewport, Zvalue is for the zbuffer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="GET_VIEWPORT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>get_viewport()</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to a structure containing the X_Pos,Y_Pos,Width,Height,MinZ,and
MaxZ values of the viewport.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="BEGIN_SCENE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>begin_scene()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>You must call this routine before rendering any 3D graphics.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="END_SCENE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>end_scene()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>You must call this after you're finished rendering any 3D graphics
and before you call begin_scene() again.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="GET_D3D_MEMORY_MODE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>get_d3d_memory_mode()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Software mode</dt>

<dt>
1 = Hardware mode</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns the memory mode which create3d_device() initialized
into.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<p>
<hr WIDTH="75%" COLOR="#FF0000">
<center>
<p><a NAME="D3_RS"></a><u><font face="Comic Sans MS"><font color="#FF0000"><font size=+2>Render
Scene Routines</font></font></font></u></center>

<p><br>
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_ANTIALIAS_SORTDEPENDENT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_antialias_sortdependent()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets antialiasing to be dependent on the order of the polygons.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_ANTIALIAS_SORTINDEPENDENT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_antialias_sortindependent()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets antialiasing to be independent of the order of the polygons.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_ANTIALIAS_NONE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_antialias_none()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets antialiasing off. This is the default.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_ENABLE_ALPHABLEND"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_enable_alphablend()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Enables alphablended transparency.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_DISABLE_ALPHABLEND"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_disable_alphablend()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Disables alphablended transparency.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_SRCBLEND"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_srcblend(
<i>atom
Alphablend </i>)</font>
<blockquote><b><i>Alphablend</i></b> is a <b><a href="globals.html#D3DBLEND">D3DBLEND
Constant</a></b></blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets up alphablending states. This routine is used in conjunction
with rs_destblend().</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_DESTBLEND"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_destblend(
<i>atom
Alphablend </i>)</font>
<blockquote><b><i>AlphaBlend</i></b> is a <b><a href="globals.html#D3DBLEND">D3DBLEND
Constant</a></b></blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets up alphablending states. This routine is used in conjunction
with rs_destblend().</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_ENABLE_Z_BUFFERING"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_enable_z_buffering()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Enables Z buffering.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_ENABLE_W_BUFFERING"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_enable_w_buffering()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Enables W buffering.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_DISABLE_DEPTH_BUFFERING"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_disable_depth_buffering()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Disable Z-based or W-based depth buffering, whichever is being
used.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_ENABLE_LIGHTING"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_enable_lighting()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Enables lighting effects.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_DISABLE_LIGHTING"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_disable_lighting()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Disables lighting effects.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="RS_SET_AMBIENT_COLOR"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>rs_set_ambient_color(
<i>atom
Color </i>)</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets the ambient lighting to the specified color. IE #FFFFFFFF
= White, #FF000000 = Red, #00FF0000 = Green, #0000FF00 = Blue</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<p>
<hr WIDTH="75%" COLOR="#FF0000">
<center>
<p><a NAME="D3_TF"></a><u><font face="Comic Sans MS"><font color="#FF0000"><font size=+2>Transform
Routines</font></font></font></u></center>

<p><br>
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SET_TRANSFORM_WORLD"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>set_transform_world(
<i>atom
World_Matrix_Pntr </i>)</font>
<blockquote><b><i>World_Matrix_Pntr</i></b> is a pointer to the matrix
to be used for world transformations.</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Setting this matrix will effect the entire scene. Use the Global
variable <b><a href="globals.html#MATWORLD">matWorld</a></b> for this.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SET_TRANSFORM_VIEW"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>set_transform_view(
<i>atom
View_Matrix_Pntr </i>)</font>
<blockquote><b><i>View_Matrix_Pntr</i></b> is a pointer to the matrix to
be used for view transformations.</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Setting this matrix will effect camera view. Use the Global
variable <b><a href="globals.html#MATVIEW">matView</a></b> for this.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SET_TRANSFORM_PROJECTION"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>set_transform_projection(
<i>atom
Projection_Matrix_Pntr </i>)</font>
<blockquote><b><i>Projection_Matrix_Pntr</i></b> is a pointer to the matrix
to be used for projection transformations.</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Setting this will effect how the scene is rendered to 2D. Use
the Global variable <b><a href="globals.html#MATPROJ">matProj</a></b> for
this.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="GET_TRANSFORM_WORLD"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>get_transform_world(
<i>atom
World_Matrix_Pntr </i>)</font>
<blockquote><b><i>World_Matrix_Pntr</i></b> is a pointer to memory where
you want the returned matrix to be placed.</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Puts the world transformation matrix in the memory location
that World_Matrix_Pntr points to, returning the same pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="GET_TRANSFORM_VIEW"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>get_transform_view(
<i>atom
View_Matrix_Pntr </i>)</font>
<blockquote><b><i>View_Matrix_Pntr</i></b> is a pointer to memory where
you want the returned matrix to be placed.</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Puts the view transformation matrix in the memory location
that View_Matrix_Pntr points to, returning the same pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="GET_TRANSFORM_PROJECTION"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>get_transform_projection(
<i>atom
Projection_Matrix_Pntr </i>)</font>
<blockquote><b><i>Projection_Matrix_Pntr</i></b> is a pointer to memory
where you want the returned matrix to be placed.</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Puts the projection transformation matrix in the memory location
that Projection_Matrix_Pntr points to, returning the same pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<p>
<hr WIDTH="75%" COLOR="#FF0000">
<center>
<p><a NAME="D3_ML"></a><u><font face="Comic Sans MS"><font color="#FF0000"><font size=+2>Materials
and Lighting Routines</font></font></font></u></center>

<p><br>
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SET_MATERIALS"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>set_materials(
<i>atom
Material_Pntr </i>)</font>
<blockquote><b><i>Material_Pntr </i></b>is a pointer to memory where the
materials structure is located</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets the material to the material structure at the specified
pointer. Use the Global variable <b><a href="globals.html#MATERIAL">material</a></b>
for this</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SET_LIGHT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>set_light(<i>
atom Light_Index, atom Light_Pntr </i>)</font>
<blockquote><b><i>Light_Index</i></b> is the light that you want to set
<br><b><i>Light_Pntr</i></b> is a pointer to memory where the light structure
is located</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets the light to the light structure at the specified pointer.
Use the Global variable <b><a href="globals.html#LIGHT">light</a></b> for
this</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="GET_LIGHT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>get_light(
<i>atom
Light_Index, atom Light_Pntr</i>)</font>
<blockquote><b><i>Light_Index</i></b> is the light that you want to get
<br><b><i>Light_Pntr</i></b> is a pointer to memory where the light structure
is to be placed</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Places the the specified light structure in the memory location,
returning the specified pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="LIGHT_ENABLE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>light_enable(
<i>atom
Light_Index, atom Enable </i>)</font>
<blockquote><b><i>Light_Index</i></b> is the light you want to enable/disable
<br><b><i>Enable</i></b> is either 0=OFF, 1=ON</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Enables/Disables the specified light.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<p>
<hr WIDTH="75%" COLOR="#FF0000">
<center>
<p><a NAME="D3_TX"></a><u><font face="Comic Sans MS"><font color="#FF0000"><font size=+2>Texture
Routines</font></font></font></u></center>

<p><br>
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="LOAD_TEXTURE_BITMAP"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>load_texture_bitmap(
<i>sequence
Texture, atom BPP, atom Flags, atom Pixel_Format, atom Memory_Mode
</i>)</font>
<blockquote><b><i>Texture</i></b> is the Bitmap you want to use
<br><b><i>BPP</i></b> is the bitdepth of the specified Texture
<br><b><i>Flags</i></b> : See the exotica API docs for info on what flags
you can use
<br><b><i>Pixel_Format</i></b> : See the exotica API docs for info
<br><b><i>Memory_Mode</i></b> is either 0=Software, or 1=Hardware</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>0 = Failure
<br>otherwise it returns the Texture_ID</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Load a bitmap as a texture for use with D3D routines. Returns
the Texture_ID, 0 on failure.
<br>If you load many textures, you can use load_texture_failed(), instead
of checking for success each time.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="LOAD_TEXTURE_FAILED"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>load_texture_bitmap_failed()</font></td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>0 = False
<dt>
1 = True</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Retutrns True if any of the previously loaded textures failed
on loading.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="FREE_TEXTURE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>free_texture(
<i>atom
Texture_ID </i>)</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Frees the texture with the specified Texture_ID. exotica_exit()
will do this.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SET_TEXTURE_STAGE_STATE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>set_texture_stage_state(
<i>atom
Stage, atom State, atom Value_Pntr </i>)</font>
<blockquote><b><i>Stage </i></b>is an identifier for the texture you want
to set the state of. In the range 0-7
<br><i><b>State</b> </i>is a <b><a href="globals.html#D3DTEXTURESTATE">D3DTEXTURESTATE
constant</a></b>
<br><b><i>Value_Pntr</i></b> is a pointer to the value to be set. This
depends on the state to be set</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Sets the state of a texture. IE bump map, environment map,
etc..</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="GET_TEXTURE_STAGE_STATE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>get_texture_stage_state(<i>
atom Stage, atom State, atom Value_Pntr </i>)</font>
<blockquote>See above for parameter details</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns the Value_Pntr for the stage state of the currently
assigned texture.
<br>According to Todd Riggins, this routine isn't working right.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="IS_TEXTURE_FORMAT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>is_texture_format(<i>
atom Bitdepth, atom Flags, atom Pixel_Format </i>)</font>
<blockquote><b><i>Bitdepth </i></b>is either 8,16,24,or 32
<br><b><i>Flags</i></b> : see the exotica docs for info
<br><b><i>Pixel _Format</i></b> : see the exotica docs for info</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Use this routine to test whether a given texture format is
available on your system.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SET_TEXTURE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>set_texture(
<i>atom
Stage, atom Texture_ID </i>)</font>
<blockquote><b><i>Stage </i></b>is an identifier you want to assign a texture
to
<br><b><i>Texture_ID</i></b> is the ID number of the texture you want to
assign to the given Stage</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Assign the specified texture to the given stage.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<p>
<hr WIDTH="75%" COLOR="#FF0000">
<center>
<p><a NAME="D3_DP"></a><u><font face="Comic Sans MS"><font color="#FF0000"><font size=+2>Draw
Primitives Routines</font></font></font></u></center>

<p><br>
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="DRAW_PRIMITIVE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>draw_primitive(
<i>atom
Primitive_Type, atom Vertex_Type, atom Vertices_Pntr, atom Vertex_Count
</i>)</font>
<blockquote><b><i>Primitive_Type</i></b> is a <b><a href="globals.html#D3DPRIMITIVETYPE">D3DPRIMITIVETYPE
constant</a></b>
<br><b><i>Vertex_Type</i></b> is <b><a href="globals.html#D3DVERTEXTYPE">D3DVERTEXTYPE
constant</a></b>
<br><b><i>Vertices_Pntr </i></b>is a pointer to the memory location where
your vertices are
<br><b><i>Vertex_Count</i></b> is the number of vertices to be rendered</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Renders the specified vertices as a sequence of the specified
primitive type. See the Exotica API docs for detailed info.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="DRAW_INDEXED_PRIMITIVE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>draw_indexed_primitive(<i>
atom Primitive_Type, atom Vertex_Type, atom Vertices_Pntr, atom Vertex_Count,
atom Index_Pntr, atom Index_Count </i>)</font>
<blockquote><b><i>Primitive_Type</i></b> is a <b><a href="globals.html#D3DPRIMITIVETYPE">D3DPRIMITIVETYPE
constant</a></b>
<br><b><i>Vertex_Type</i></b> is <b><a href="globals.html#D3DVERTEXTYPE">D3DVERTEXTYPE
constant</a></b>
<br><b><i>Vertices_Pntr </i></b>is a pointer to the memory location where
your vertices are
<br><b><i>Vertex_Count</i></b> is the number of vertices in the vertex
list
<br><b><i>Index_Pntr</i></b> is a pointer to the memory location where
the Indexed list of vertices are
<br><b><i>Index_Count</i></b> is the number of indexed vertices to be rendered</blockquote>
</td>
</tr>

<tr>
<td>
<dl><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>integer</font>
<dl>
<dt>
0 = Success&nbsp;</dt>

<dt>
1 = Failure&nbsp;</dt>
</dl>
</dl>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Renders the specified primitive type by indexing into the array
of vertices. See the Exotica API docs for details.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<p>
<hr WIDTH="75%" COLOR="#FF0000">
<center>
<p><a NAME="D3_M"></a><u><font face="Comic Sans MS"><font color="#FF0000"><font size=+2>Math
Routines</font></font></font></u></center>

<p><br>
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="CROSS_PRODUCT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>cross_product(<i>
atom Vector1_Pntr, atom Vector2_Pntr </i>)</font></td>
</tr>

<tr>
<td><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to a vector which is the cross product of
the two specified vectors.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="DOT_PRODUCT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>dot_product(
<i>atom
Vector1_Pntr, atom Vector2_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to the dot product of the two specified vectors.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="SQUARE_MAGNITUDE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>square_magnitude(
<i>atom
Vector_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to the square magnitude of the given vector.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="MAGNITUDE"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>magnitude(
<i>atom
Vector_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to the magnitude of the specified vector.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="MAX_COMPONENT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>max_component(
<i>atom
Vector_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to the max component of the given vector.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="MIN_COMPONENT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>min_component(
<i>atom
Vector_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to the min component of the given vector.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="MAXIMIZE_COMPONENTS"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>maximize_components(
<i>atom
Vector1_Pntr, atom Vector2_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to a vector that is the max components of
the two vectors combined.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="MINIMIZE_COMPONENTS"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>minimize_components(
<i>atom
Vector1_Pntr, atom Vector2_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to a vector that is the min components of
the two vectors combined.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="NORMALIZE_VECTOR"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>normalize_vector(
<i>atom
Vector_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns a pointer to normalized vector.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="MATRIX_MULTIPLY"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>matrix_multiply(
<i>atom
Dest_Matrix_Pntr, atom Src_Matrix1_Pntr, atom Src_Matrix2_Pntr
</i>)</font>
<blockquote><b><i>Dest_Matrix_Pntr</i></b> is a pointer to where you want
the returned matrix to be located
<br><b><i>Src_Matrix1_Pntr</i></b> is a pointer to the first matrix to
be multiplied
<br><b><i>Src_Matrix2_Pntr</i></b> is a pointer to the second matrix to
be multiplied</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Multiplies the two given matrices, placing the product at the
specified pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="MATRIX_INVERT"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>matrix_invert(
<i>atom
Dest_Matrix_Pntr, atom Src_Matrix_Pntr </i>)</font>
<blockquote><b><i>Dest_Matrix_Pntr</i></b> is a pointer to where you want
the returned matrix to be located
<br><b><i>Src_Matrix_Pntr</i></b> is a pointer to the matrix to be inverted</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Places the invert of the given matrix at the specified pointer.
Returns the specified pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="VECTOR_MATRIX_MULTIPLY"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>vector_matrix_multiply(
<i>atom
Dest_Vector_Pntr, atom Src_Vector_Pntr, atom Src_Matrix_Pntr </i>)</font>
<blockquote><b><i>Dest_Vector_Pntr</i></b> is a pointer to where you want
the returned matrix to be located
<br><b><i>Src_Vector_Pntr</i></b> is a pointer to the vector to be multiplied
<br><b><i>Src_Matrix_Pntr</i></b> is a pointer to the matrix to be multiplied</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Multiplies the vector by the matrix, placing the product at
the specified pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="VERTEX_MATRIX_MULTIPLY"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>vertex_matrix_multiply(
<i>atom
Dest_Vertex_Pntr, atom Src_Vertex_Pntr, Src_Matrix_Pntr </i>)</font>
<blockquote><b><i>Dest_Veretex_Pntr</i></b> is a pointer to where you want
the returned matrix to be located
<br><b><i>Src_Vertex_Pntr</i></b> is a pointer to the vertex to be multiplied
<br><b><i>Src_Matrix_Pntr</i></b> is a pointer to the matrix to be multiplied</blockquote>
</td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Multiplies the vector by the matrix, placing the product at
the specified pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="QUATERNION_FROM_ROTATION"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>quaternion_from_rotation(
<i>atom
Dest_X_Pntr, atom Dest_Y_Pntr, atom Dest_Z_Pntr, atom Dest_W_Pntr, atom
Src_Vector_Pntr, atom Src_Theta </i>)</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Creates quaternion values from the Vector and the Theta angle.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="ROTATION_FROM_QUATERNION"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>rotation_from_quaternion(
<i>atom
Dest_Vector_Pntr, atom Dest_Theta_Pntr, atom Src_X, atom Src_Y, atom Src_Z,
atom Src_W </i>)</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Creates a Vector and Theta angle from the quaternion values.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="QUATERNION_FROM_ANGLES"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>quaternion_from_angles(
<i>atom
Dest_X_Pntr, atom Dest_Y_Pntr, atom Dest_Z_Pntr, atom Dest_W_Pntr, atom
Src_Yaw, atom Src_Pitch, atom Src_Roll</i> )</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Creates quaternion values from the given angles.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="MATRIX_FROM_QUATERNION"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>matrix_form_quaternion(
<i>atom
Dest_Matrix_Pntr, atom Src_X, atom Src_Y, atom Src_Z, atom Src_W
</i>)</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Creates a matrix from the given quaternion values.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="QUATERNION_FROM_MATRIX"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>quaternion_form_matrix(
<i>atom
Dest_X_Pntr, atom Dest_Y_Pntr, atom Dest_Z_Pntr, atom Dest_W_Pntr, atom
Src_Matrix_Pntr </i>)</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Creates a quaternion from a matrix.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="QUATERNION_MULTIPLY"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>quaternion_multiply(
<i>atom
Dest_X_Pntr, Dest_Y_Pntr, atom Dest_Z_Pntr, atom Dest_W_Pntr, atom Src_X1_Pntr,
Src_Y1_Pntr, atom Src_Z1_Pntr, atom Src_W1_Pntr, atom Src_X2_Pntr, Src_Y2_Pntr,
atom Src_Z2_Pntr, atom Src_W2_Pntr</i> )</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Multiply two quternions.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 COLS=1 WIDTH="75%" >
<tr>
<td><a NAME="QUATERNION_SLERP"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Procedure:
</font></font></b>quaternion_slerp(
<i>atom
Dest_X_Pntr, Dest_Y_Pntr, atom Dest_Z_Pntr, atom Dest_W_Pntr, atom Src_X1_Pntr,
Src_Y1_Pntr, atom Src_Z1_Pntr, atom Src_W1_Pntr, atom Src_X2_Pntr, Src_Y2_Pntr,
atom Src_Z2_Pntr, atom Src_W2_Pntr</i> )</font></td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>I don't know! Slerps two quaternions...</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 >
<tr ALIGN=CENTER>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<br>&nbsp;
<center><table BORDER CELLPADDING=0 WIDTH="75%" HEIGHT="67" >
<tr>
<td><a NAME="MAKE_IDENTITY_MATRIX"></a><font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Function:
</font></font></b>make_identity_matrix(
<i>atom
Matrix_Pntr </i>)</font></td>
</tr>

<tr>
<td>
<dt>
<font face="Comic Sans MS"><b><font color="#FF0000"><font size=+1>Returns:
</font></font></b>atom</font></dt>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>Description:</font></font></font></b>
<blockquote>Returns an Identity matrix to the given pointer.</blockquote>
</td>
</tr>

<tr>
<td><b><font face="Comic Sans MS"><font color="#FF0000"><font size=+1>See
also:</font></font></font></b>
<center><table CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH="100%" >
<tr>
<td></td>

<td></td>

<td></td>
</tr>
</table></center>
</td>
</tr>
</table></center>

<center>
<p>
<hr WIDTH="75%" COLOR="#FF0000">
<p><b><i><u><font face="Comic Sans MS"><font size=+2><a href="#TOP">Back
To Top</a></font></font></u></i></b></center>

</body>
</html>
